unit Makedb;
(*
 Table Scanner V3.00 - Released August, 1998 [unregistered copy]
 Copyright 1997-1998 by Demian [demian@bhnet.com.br]
 Requires TBLSCN16.DLL (Delphi 1) or TBLSCN.DLL (Delphi 2/3/4)

 CheckTables parameters:
 1. Boolean (REQUIRED): unconditional restructuring
 2. String (optional): target directory
 3. Pointer (optional): TScanEvent

 Full syntax: CheckTables([false,'C:\TEMP',@MyFunc])
 Minimum syntax: CheckTables([false])
*)

{DO NOT REMOVE THE LINE BELOW!}
{$IFDEF WIN32}{$H-}{$ENDIF}{$A-}{$X+}{$P+}{$U+}

interface

uses
  {$IFDEF WIN32}BDE,Windows{$ELSE}DBIProcs,DBITypes,WinProcs,WinTypes{$ENDIF},SysUtils;

type 
  TScanAction = (saStart,saFinish,saVerify,saCreate,saModify,saRedo);
  TScanInfo = record
    Action: TScanAction;
    TableCount: integer;
    TableIndex: integer;
    TableName : string;
    BDEMessage: string;
  end;
  TScanEvent = function(const Sender: TScanInfo): boolean;

procedure CheckTables(const Args: array of const);

implementation

type
  TDef = procedure(const Args: array of const);

var
  Def: TDef;
  pAddress: TFarProc;


{______________________________________________________________________________}
procedure Table001; export; {ANIMALS.DBF}
begin
  Def([1,'ANIMALS.DBF','','DB437US0',5,1,0,0]);
  Def([2,'NAME',fldDBCHAR,0,10,0]);
  Def([2,'SIZE',fldDBNUM,0,2,0]);
  Def([2,'WEIGHT',fldDBNUM,0,2,0]);
  Def([2,'AREA',fldDBCHAR,0,20,0]);
  Def([2,'BMP',fldDBBINARY,0,10,0]);
  Def([3,'ANIMALS.MDX','NAME','NAME','',1,-1,0,1,513,1024,0]);
end;

{______________________________________________________________________________}
procedure Table002; export; {BIOLIFE.DB}
begin
  Def([1,'BIOLIFE.DB','','ascii',8,1,0,0]);
  Def([2,'Species No',fldPDXNUM,0,1,0]);
  Def([2,'Category',fldPDXCHAR,0,15,0]);
  Def([2,'Common_Name',fldPDXCHAR,0,30,0]);
  Def([2,'Species Name',fldPDXCHAR,0,40,0]);
  Def([2,'Length (cm)',fldPDXNUM,0,1,0]);
  Def([2,'Length_In',fldPDXNUM,0,1,0]);
  Def([2,'Notes',fldPDXMEMO,0,50,0]);
  Def([2,'Graphic',fldPDXGRAPHIC,0,0,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
end;

{______________________________________________________________________________}
procedure Table003; export; {CLIENTS.DBF}
begin
  Def([1,'CLIENTS.DBF','','DB437US0',17,0,0,0]);
  Def([2,'LAST_NAME',fldDBCHAR,0,20,0]);
  Def([2,'FIRST_NAME',fldDBCHAR,0,20,0]);
  Def([2,'ACCT_NBR',fldDBNUM,0,20,4]);
  Def([2,'ADDRESS_1',fldDBCHAR,0,20,0]);
  Def([2,'CITY',fldDBCHAR,0,20,0]);
  Def([2,'STATE',fldDBCHAR,0,2,0]);
  Def([2,'ZIP',fldDBCHAR,0,5,0]);
  Def([2,'TELEPHONE',fldDBCHAR,0,12,0]);
  Def([2,'DATE_OPEN',fldDBDATE,0,8,0]);
  Def([2,'SS_NUMBER',fldDBNUM,0,20,4]);
  Def([2,'PICTURE',fldDBCHAR,0,15,0]);
  Def([2,'BIRTH_DATE',fldDBDATE,0,8,0]);
  Def([2,'RISK_LEVEL',fldDBCHAR,0,8,0]);
  Def([2,'OCCUPATION',fldDBCHAR,0,20,0]);
  Def([2,'OBJECTIVES',fldDBCHAR,0,10,0]);
  Def([2,'INTERESTS',fldDBCHAR,0,120,0]);
  Def([2,'IMAGE',fldDBBINARY,0,10,0]);
end;

{______________________________________________________________________________}
procedure Table004; export; {COUNTRY.DB}
begin
  Def([1,'COUNTRY.DB','','intl850',5,1,0,0]);
  Def([2,'Name',fldPDXCHAR,0,24,0]);
  Def([2,'Capital',fldPDXCHAR,0,24,0]);
  Def([2,'Continent',fldPDXCHAR,0,24,0]);
  Def([2,'Area',fldPDXNUM,0,1,0]);
  Def([2,'Population',fldPDXNUM,0,1,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
end;

{______________________________________________________________________________}
procedure Table005; export; {CUSTOLY.DB}
begin
  Def([1,'CUSTOLY.DB','','ascii',14,3,0,0]);
  Def([2,'CustNo',fldPDXAUTOINC,0,1,0]);
  Def([2,'Last_Name',fldPDXCHAR,0,30,0]);
  Def([2,'First_Name',fldPDXCHAR,0,30,0]);
  Def([2,'VIP_Status',fldPDXCHAR,0,10,0]);
  Def([2,'Address1',fldPDXCHAR,0,40,0]);
  Def([2,'Address2',fldPDXCHAR,0,40,0]);
  Def([2,'City',fldPDXCHAR,0,20,0]);
  Def([2,'State/Prov',fldPDXCHAR,0,10,0]);
  Def([2,'Post_Code',fldPDXCHAR,0,10,0]);
  Def([2,'Country',fldPDXCHAR,0,10,0]);
  Def([2,'Phone',fldPDXCHAR,0,18,0]);
  Def([2,'Fax',fldPDXCHAR,0,18,0]);
  Def([2,'EMail',fldPDXCHAR,0,40,0]);
  Def([2,'Remarks',fldPDXMEMO,0,200,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
  Def([3,'City','','','',7,-1,7,1,0,2048,0]);
  Def([3,'Names','','','',2,3,-1,256,2,0,2048,64]);
end;

{______________________________________________________________________________}
procedure Table006; export; {CUSTOMER.DB}
begin
  Def([1,'CUSTOMER.DB','','ascii',13,2,0,0]);
  Def([2,'CustNo',fldPDXNUM,0,1,0]);
  Def([2,'Company',fldPDXCHAR,0,30,0]);
  Def([2,'Addr1',fldPDXCHAR,0,30,0]);
  Def([2,'Addr2',fldPDXCHAR,0,30,0]);
  Def([2,'City',fldPDXCHAR,0,15,0]);
  Def([2,'State',fldPDXCHAR,0,20,0]);
  Def([2,'Zip',fldPDXCHAR,0,10,0]);
  Def([2,'Country',fldPDXCHAR,0,20,0]);
  Def([2,'Phone',fldPDXCHAR,0,15,0]);
  Def([2,'FAX',fldPDXCHAR,0,15,0]);
  Def([2,'TaxRate',fldPDXNUM,0,1,0]);
  Def([2,'Contact',fldPDXCHAR,0,20,0]);
  Def([2,'LastInvoiceDate',fldPDXDATETIME,0,1,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
  Def([3,'ByCompany','','','',2,-1,256,1,0,2048,64]);
end;

{______________________________________________________________________________}
procedure Table007; export; {EMPLOYEE.DB}
begin
  Def([1,'EMPLOYEE.DB','','ascii',6,2,0,0]);
  Def([2,'EmpNo',fldPDXLONG,0,1,0]);
  Def([2,'LastName',fldPDXCHAR,0,20,0]);
  Def([2,'FirstName',fldPDXCHAR,0,15,0]);
  Def([2,'PhoneExt',fldPDXCHAR,0,4,0]);
  Def([2,'HireDate',fldPDXDATETIME,0,1,0]);
  Def([2,'Salary',fldPDXNUM,0,1,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
  Def([3,'ByName','','','',2,3,-1,256,2,0,2048,64]);
end;

{______________________________________________________________________________}
procedure Table008; export; {EVENTS.DB}
begin
  Def([1,'EVENTS.DB','','ascii',8,2,0,0]);
  Def([2,'EventNo',fldPDXAUTOINC,0,1,0]);
  Def([2,'VenueNo',fldPDXLONG,0,1,0]);
  Def([2,'Event_Name',fldPDXCHAR,0,30,0]);
  Def([2,'Event_Date',fldPDXDATE,0,1,0]);
  Def([2,'Event_Time',fldPDXTIME,0,1,0]);
  Def([2,'Event_Description',fldPDXMEMO,0,100,0]);
  Def([2,'Ticket_price',fldPDXMONEY,0,1,0]);
  Def([2,'Event_Photo',fldPDXGRAPHIC,0,0,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
  Def([3,'Date_Time','','','',3,4,-1,256,2,0,2048,64]);
end;

{______________________________________________________________________________}
procedure Table009; export; {HOLDINGS.DBF}
begin
  Def([1,'HOLDINGS.DBF','','DB437US0',5,2,0,0]);
  Def([2,'ACCT_NBR',fldDBNUM,0,7,0]);
  Def([2,'SYMBOL',fldDBCHAR,0,7,0]);
  Def([2,'SHARES',fldDBFLOAT,0,12,2]);
  Def([2,'PUR_PRICE',fldDBFLOAT,0,6,2]);
  Def([2,'PUR_DATE',fldDBDATE,0,8,0]);
  Def([3,'HOLDINGS.MDX','SYMBOL','SYMBOL','',2,-1,0,1,513,1024,0]);
  Def([3,'HOLDINGS.MDX','ACCT_NBR','ACCT_NBR','',1,-1,0,1,529,1024,0]);
end;

{______________________________________________________________________________}
procedure Table010; export; {INDUSTRY.DBF}
begin
  Def([1,'INDUSTRY.DBF','','DB850PT0',3,1,0,0]);
  Def([2,'IND_CODE',fldDBNUM,0,4,0]);
  Def([2,'IND_NAME',fldDBCHAR,0,5,0]);
  Def([2,'LONG_NAME',fldDBCHAR,0,20,0]);
  Def([3,'INDUSTRY.MDX','IND_CODE','IND_CODE','',1,-1,0,1,529,1024,0]);
end;

{______________________________________________________________________________}
procedure Table011; export; {ITEMS.DB}
begin
  Def([1,'ITEMS.DB','','ascii',5,3,0,2]);
  Def([2,'OrderNo',fldPDXNUM,0,1,0]);
  Def([2,'ItemNo',fldPDXNUM,0,1,0]);
  Def([2,'PartNo',fldPDXNUM,0,1,0]);
  Def([2,'Qty',fldPDXLONG,0,1,0]);
  Def([2,'Discount',fldPDXNUM,0,1,0]);
  Def([3,'','','','',1,2,-1,0,2,0,2048,6]);
  Def([3,'PartNo','','','',3,-1,3,1,0,2048,0]);
  Def([3,'ByOrderNo','','','',1,-1,256,1,0,2048,64]);
  Def([5,1,1,1,-1,1,-1,'RefOrders','ORDERS.DB',1,0,0]);
  Def([5,2,1,3,-1,1,-1,'CheckPartNo','PARTS.DB',1,0,0]);
end;

{______________________________________________________________________________}
procedure Table016; export; {ORDERS.DB}
begin
  Def([1,'ORDERS.DB','','ascii',21,2,2,1]);
  Def([2,'OrderNo',fldPDXNUM,0,1,0]);
  Def([2,'CustNo',fldPDXNUM,0,1,0]);
  Def([2,'SaleDate',fldPDXDATETIME,0,1,0]);
  Def([2,'ShipDate',fldPDXDATETIME,0,1,0]);
  Def([2,'EmpNo',fldPDXLONG,0,1,0]);
  Def([2,'ShipToContact',fldPDXCHAR,0,20,0]);
  Def([2,'ShipToAddr1',fldPDXCHAR,0,30,0]);
  Def([2,'ShipToAddr2',fldPDXCHAR,0,30,0]);
  Def([2,'ShipToCity',fldPDXCHAR,0,15,0]);
  Def([2,'ShipToState',fldPDXCHAR,0,20,0]);
  Def([2,'ShipToZip',fldPDXCHAR,0,10,0]);
  Def([2,'ShipToCountry',fldPDXCHAR,0,20,0]);
  Def([2,'ShipToPhone',fldPDXCHAR,0,15,0]);
  Def([2,'ShipVIA',fldPDXCHAR,0,7,0]);
  Def([2,'PO',fldPDXCHAR,0,15,0]);
  Def([2,'Terms',fldPDXCHAR,0,6,0]);
  Def([2,'PaymentMethod',fldPDXCHAR,0,7,0]);
  Def([2,'ItemsTotal',fldPDXMONEY,0,1,0]);
  Def([2,'TaxRate',fldPDXNUM,0,1,0]);
  Def([2,'Freight',fldPDXMONEY,0,1,0]);
  Def([2,'AmountPaid',fldPDXMONEY,0,1,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
  Def([3,'CustNo','','','',2,-1,2,1,0,2048,0]);
  Def([4,2,2,0,-1,0,-1,0,-1,'','',0]);
  Def([4,5,2,0,0,0,128,-1,0,0,0,128,-1,0,0,0,128,-1,'','',0]);
  Def([5,1,1,2,-1,1,-1,'RefCustinOrders','CUSTOMER.DB',1,0,0]);
end;

{______________________________________________________________________________}
procedure Table017; export; {PARTS.DB}
begin
  Def([1,'PARTS.DB','','ascii',7,3,0,1]);
  Def([2,'PartNo',fldPDXNUM,0,1,0]);
  Def([2,'VendorNo',fldPDXNUM,0,1,0]);
  Def([2,'Description',fldPDXCHAR,0,30,0]);
  Def([2,'OnHand',fldPDXNUM,0,1,0]);
  Def([2,'OnOrder',fldPDXNUM,0,1,0]);
  Def([2,'Cost',fldPDXMONEY,0,1,0]);
  Def([2,'ListPrice',fldPDXMONEY,0,1,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
  Def([3,'VendorNo','','','',2,-1,2,1,0,2048,0]);
  Def([3,'ByDescription','','','',3,-1,256,1,0,2048,64]);
  Def([5,1,1,2,-1,1,-1,'CheckVendor','VENDORS.DB',1,0,0]);
end;

{______________________________________________________________________________}
procedure Table019; export; {VENDORS.DB}
begin
  Def([1,'VENDORS.DB','','ascii',11,1,0,0]);
  Def([2,'VendorNo',fldPDXNUM,0,1,0]);
  Def([2,'VendorName',fldPDXCHAR,0,30,0]);
  Def([2,'Address1',fldPDXCHAR,0,30,0]);
  Def([2,'Address2',fldPDXCHAR,0,30,0]);
  Def([2,'City',fldPDXCHAR,0,20,0]);
  Def([2,'State',fldPDXCHAR,0,20,0]);
  Def([2,'Zip',fldPDXCHAR,0,10,0]);
  Def([2,'Country',fldPDXCHAR,0,15,0]);
  Def([2,'Phone',fldPDXCHAR,0,15,0]);
  Def([2,'FAX',fldPDXCHAR,0,15,0]);
  Def([2,'Preferred',fldPDXBOOL,0,1,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
end;

{______________________________________________________________________________}
procedure Table012; export; {MASTER.DBF}
begin
  Def([1,'MASTER.DBF','','DB437US0',17,3,0,0]);
  Def([2,'SYMBOL',fldDBCHAR,0,7,0]);
  Def([2,'CO_NAME',fldDBCHAR,0,20,0]);
  Def([2,'EXCHANGE',fldDBCHAR,0,8,0]);
  Def([2,'CUR_PRICE',fldDBFLOAT,0,7,3]);
  Def([2,'YRL_HIGH',fldDBFLOAT,0,7,3]);
  Def([2,'YRL_LOW',fldDBFLOAT,0,7,3]);
  Def([2,'P_E_RATIO',fldDBFLOAT,0,7,2]);
  Def([2,'BETA',fldDBFLOAT,0,4,2]);
  Def([2,'PROJ_GRTH',fldDBNUM,0,5,0]);
  Def([2,'INDUSTRY',fldDBNUM,0,4,0]);
  Def([2,'PRICE_CHG',fldDBNUM,0,3,0]);
  Def([2,'SAFETY',fldDBNUM,0,3,0]);
  Def([2,'RATING',fldDBCHAR,0,4,0]);
  Def([2,'RANK',fldDBNUM,0,4,2]);
  Def([2,'OUTLOOK',fldDBNUM,0,1,0]);
  Def([2,'RCMNDATION',fldDBCHAR,0,5,0]);
  Def([2,'RISK',fldDBCHAR,0,4,0]);
  Def([3,'MASTER.MDX','SYMBOL','SYMBOL','',1,-1,0,1,513,1024,4]);
  Def([3,'MASTER.MDX','GROWTHASC','PROJ_GRTH','',9,-1,0,1,529,1024,0]);
  Def([3,'MASTER.MDX','GROWTHDESC','PROJ_GRTH','',9,-1,0,1,529,1024,8]);
end;

{______________________________________________________________________________}
procedure Table013; export; {NEXTCUST.DB}
begin
  Def([1,'NEXTCUST.DB','','ascii',1,0,0,0]);
  Def([2,'NewCust',fldPDXNUM,0,1,0]);
end;

{______________________________________________________________________________}
procedure Table014; export; {NEXTITEM.DB}
begin
  Def([1,'NEXTITEM.DB','','ascii',1,0,0,0]);
  Def([2,'NewKey',fldPDXNUM,0,1,0]);
end;

{______________________________________________________________________________}
procedure Table015; export; {NEXTORD.DB}
begin
  Def([1,'NEXTORD.DB','','ascii',1,0,0,0]);
  Def([2,'NewKey',fldPDXNUM,0,1,0]);
end;

{______________________________________________________________________________}
procedure Table018; export; {RESERVAT.DB}
begin
  Def([1,'RESERVAT.DB','','ascii',11,3,0,0]);
  Def([2,'ResNo',fldPDXAUTOINC,0,1,0]);
  Def([2,'EventNo',fldPDXLONG,0,1,0]);
  Def([2,'CustNo',fldPDXLONG,0,1,0]);
  Def([2,'NumTickets',fldPDXLONG,0,1,0]);
  Def([2,'Amt_Paid',fldPDXMONEY,0,1,0]);
  Def([2,'Pay_Method',fldPDXCHAR,0,10,0]);
  Def([2,'Card_No',fldPDXCHAR,0,20,0]);
  Def([2,'Card_Exp',fldPDXDATE,0,1,0]);
  Def([2,'Pay_Notes',fldPDXMEMO,0,30,0]);
  Def([2,'Purge_Date',fldPDXDATE,0,1,0]);
  Def([2,'Paid',fldPDXBOOL,0,1,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
  Def([3,'CustNo','','','',3,-1,3,1,0,2048,0]);
  Def([3,'EventNo','','','',2,-1,2,1,0,2048,0]);
end;

{______________________________________________________________________________}
procedure Table020; export; {VENUES.DB}
begin
  Def([1,'VENUES.DB','','ascii',5,1,0,0]);
  Def([2,'VenueNo',fldPDXAUTOINC,0,1,0]);
  Def([2,'Venue',fldPDXCHAR,0,30,0]);
  Def([2,'Capacity',fldPDXLONG,0,1,0]);
  Def([2,'Venue_Map',fldPDXGRAPHIC,0,0,0]);
  Def([2,'Remarks',fldPDXMEMO,0,80,0]);
  Def([3,'','','','',1,-1,0,1,0,2048,6]);
end;

{______________________________________________________________________________}
procedure AddTables;
begin
  Def([@Table001,'ANIMALS.DBF']);
  Def([@Table002,'BIOLIFE.DB']);
  Def([@Table003,'CLIENTS.DBF']);
  Def([@Table004,'COUNTRY.DB']);
  Def([@Table005,'CUSTOLY.DB']);
  Def([@Table006,'CUSTOMER.DB']);
  Def([@Table007,'EMPLOYEE.DB']);
  Def([@Table008,'EVENTS.DB']);
  Def([@Table009,'HOLDINGS.DBF']);
  Def([@Table010,'INDUSTRY.DBF']);
  Def([@Table016,'ORDERS.DB']);
  Def([@Table019,'VENDORS.DB']);
  Def([@Table017,'PARTS.DB']);
  Def([@Table011,'ITEMS.DB']);
  Def([@Table012,'MASTER.DBF']);
  Def([@Table013,'NEXTCUST.DB']);
  Def([@Table014,'NEXTITEM.DB']);
  Def([@Table015,'NEXTORD.DB']);
  Def([@Table018,'RESERVAT.DB']);
  Def([@Table020,'VENUES.DB']);
end;

{______________________________________________________________________________}
procedure CheckTables(const Args: array of const);
type
  TGet = procedure(var ErrorMsg: string);
const
  sDLLName = {$IFDEF WIN32}'TBLSCN.DLL'{$ELSE}'TBLSCN16.DLL'{$ENDIF};
var
  hDLL: THandle;
  SysInfo: SYSConfig;
  szDLLName: DBITBLNAME;
  ErrorMsg: string;
begin
  if Args[0].VType <> vtBoolean then
    raise Exception.Create('CheckTables invalid parameter');
  DBIInit(nil);
  Fillchar(SysInfo,SizeOf(SysInfo),#0);
  DbiGetSysConfig(SysInfo);
  StrPCopy(szDLLName,ExtractFilePath(SysInfo.szIniFile)+sDLLName);
  hDLL := LoadLibrary(szDLLName);
  if hDLL < 32 then begin
    StrPCopy(szDLLName,sDLLName);
    hDLL := LoadLibrary(szDLLName);
    if hDLL < 32 then
      raise Exception.Create('Could not find '+sDLLName);
  end;
  ErrorMsg := '';
  try
    pAddress := GetProcAddress(hDLL,'DEF');
    if pAddress = nil then begin
      ErrorMsg := StrPas(szDLLName)+' invalid version';
      Abort;
    end;
    try
      Def := TDef(pAddress);
      Def([3007]);
      Def(Args);
      AddTables;
      Def([0]);
    finally
      pAddress := GetProcAddress(hDLL,'GET');
      TGet(pAddress)(ErrorMsg);
    end;
  finally
    FreeLibrary(hDLL);
    if ErrorMsg <> '' then
      raise Exception.Create(ErrorMsg);
  end;
end;

end.
